#include <HPLDXLib.h>
using namespace std;

#include <hpllib/system/HPLFile.h>
//#include "GSceneCommonProc.h"

#include <hpllib/math/HPLMath.h>
#include <time.h>
//#include "Resource.h"

#include "GStaticData.h"

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine, int nCmdShow )
{
	SetAlwaysRunFlag( TRUE );

	SetBackgroundColor( 0,50,50);
//	SetWindowIconID( MAINICON );
	SetGraphMode(
		getStaticData()->m_Setting.windowWidth ,
		getStaticData()->m_Setting.windowHeight,
		getStaticData()->m_Setting.bitPerPixel );
	// change resolution
/*	if( getStaticData()->m_SystemData.getOption( OptionType::RESOLUTION ) > ResolutionType::WIDTH640 ) {
		double dRate = getStaticData()->m_SystemData.getResolutionRate();
		SetWindowSizeExtendRate( dRate );
	}*/
	// set window mode
	if( ChangeWindowMode( TRUE ) ) 
		//getStaticData()->m_SystemData.getOption( OptionType::SCREEN_MODE) == ScreenModeType::WINDOWED ?
		//TRUE : FALSE) != DX_CHANGESCREEN_OK )
	{
		// do nothing
	}

	HPLError::assertIt( DxLib_Init() != -1,
		(char*)"system initialization failed", 3 );
	SetWindowText( "GfXEeXg");

	// }EXJ[\B
	SetMouseDispFlag( FALSE );
	
/*	// load loading pict
	int nHandle = LoadGraph( "Loading.png" );
	DrawGraph( 0,0,nHandle,FALSE );

	// Strings
	DrawString( getStaticData()->m_Setting.windowWidth - 150, getStaticData()->m_Setting.windowHeight - 100,
		"Loading...", GetColor(0,0,0));
		
	// `
	ScreenFlip();
*/

	// load images
	staticData.loadTexture();

	// select scene
	getStaticData()->m_SceneManager.setScene( SceneType::TITLE );
	int nTime = 0;

	while( staticData.isRunning()) {
		// ݂̃JEg
		nTime = GetNowCount();
		// L[͍XV
		getStaticData()->getInputManager()->update();

		// }EXWXV
		GCursor* lpCursor = getStaticData()->m_ObjectManager.getCursor();
		int nX = 0;
		int nY = 0;
		if( GetMousePoint( &nX, &nY ) == 0 ) {
			lpCursor->updateMousePos( nX, nY );
		}

		// 
		int nMouseInput = GetMouseInput();
		lpCursor->setMouseInput( nMouseInput );
		

		// |[Y{^(fobOH)
		if( getStaticData()->getInputManager()->isPressedNow( KeyMap::H ) ) {
			// the world
			getStaticData()->m_Game.setTheWorld( 
				!getStaticData()->m_Game.isTheWorld() );
		}

		// clear
		ClearDrawScreen();

		// game range update
		getStaticData()->updateGameRange();


		// 
		getStaticData()->m_SceneManager.processScene();

		// cursor draw
		lpCursor->draw();

		// ؂ւ
		if( getStaticData()->isFadingOutDX() ) {	//! ؂ւ
			// tF[hAEg\
			getStaticData()->drawFadeOutDX();
		

		}
		if( getStaticData()->isFadingOutDX() ) {	//! ؂ւ
			if( getStaticData()->processFadeOutDX( true ) == false) {	// tF[hAEg
				// tF[hAEg(傤ǍFɂȂu)


			}
		}



		// R\[R}h
//		GSceneCommonProc sceneCommonProc;
//		sceneCommonProc.consoleProc();

		ScreenFlip();

		if( ProcessMessage() != 0 || CheckHitKey( KEY_INPUT_LALT ) != 0 && CheckHitKey( KEY_INPUT_F4 ) != 0 ) {
			break;
		}

		static int nPreviousF2 = 0;
		int nCurrentF2 = CheckHitKey( KEY_INPUT_F2 );
		if( 0 != nCurrentF2 && 0 == nPreviousF2) {
			// IuWFNgNA
			getStaticData()->m_ObjectManager.clear();
			// ^Cg
			getStaticData()->m_SceneManager.setScene( SceneType::TITLE );
//			GTitleScene* lpScene = getStaticData()->getTitleScene();
//			lpScene->reset();

		}
		nPreviousF2 = nCurrentF2;

		//! ÕXN[VbgL[(F11)
		static int nPreviousScreen = 0;
		int nCurrentScreen = CheckHitKey( KEY_INPUT_F11 );
		if( 0 != nCurrentScreen && 0 == nPreviousScreen ) {
			// screen capture
			SaveDrawScreen(0,0,getStaticData()->m_Setting.windowWidth,getStaticData()->m_Setting.windowHeight,
				HPLFile::createNewCaptureFileName().c_str() );
		}
		nPreviousScreen = nCurrentScreen;
		

		while( GetNowCount() - nTime < 30 ) {
			Sleep(1);
		}

	}
	// save
	getStaticData()->m_Save.save();
//	getStaticData()->m_RIP.save();
	getStaticData()->m_MixerManager.stopMusic();
	DxLib_End();
	return 0;
}
