#include "GNeutral.h"
#include "GStaticData.h"

#include <hpllib/action/HPL3DActionMoveTool.h>

using namespace std;

///
//! ႩH
//! AyAグiEnko/Cursor)AEnkoVׂ
/*bool GNeutral::isToy() {
	return GNeutral::isToy( this->getType() );
}
bool GNeutral::isToy( int nType ) {
	switch( nType ) {
	case Sequence::Neutral::HIJIRI:
	case Sequence::Neutral::IKEN_DOLL:
	case Sequence::Neutral::LIME:
	case Sequence::Neutral::TOZICO:
	case Sequence::Neutral::TINA_DOLL:
	case Sequence::Neutral::TINSURA:
	case Sequence::Neutral::SUMANEKO:
	case Sequence::Neutral::MENTER:
	case Sequence::Neutral::SANDE:
		return true;
	}
	return false;
}

int GNeutral::getGrabType( int nNeutralType ) {
	if( GNeutral::isToy( nNeutralType ) ) {
		return GGrabType::LIFT;
	}
	switch( nType ) {
	case Sequence::Neutral::BED:
	case Sequence::Neutral::SURGEON_BED:
	case Sequence::Neutral::CHEST:
	case Sequence::Neutral::BONDAGE_WALL:
	case Sequence::Neutral::BUNBETSU:
		// ړłȂ
		return GGrabType::NO_GRAB;
	case Sequence::Neutral::IRON_BALL:
		return GGrabType::LIFT;
	default:
#ifdef _DEBUG
		ASSERT_IT_TYPE( nNeutralType, "Neutral Type");
#endif
		;
	}
	return GGrabType::NO_GRAB;
}
*/
static void addSequence( HPLSprite* lpSprite, int nSeqID ) {
	lpSprite->setSequence( nSeqID, getStaticData()->getSprite( SpriteType::NEUTRAL )->getPair( Sequence::Neutral::BATH_WATER)->clone());
}

GNeutral::GNeutral( int nType ): HPLShootingObject(nType)  {
	this->setObjectType( ObjectType::NEUTRAL );

	HPLSprite* lpSprite = new HPLSprite();
	lpSprite->setSequence( nType, getStaticData()->getSprite( SpriteType::NEUTRAL )->getPair( nType)->clone());
	switch( nType ) {
	case Sequence::Neutral::BATH:
		// water. water frontǉ
		addSequence( lpSprite, Sequence::Neutral::BATH_WATER );
		addSequence( lpSprite, Sequence::Neutral::BATH_WATER_FRONT );
		break;
	}
	this->setSprite( lpSprite ) ;
	HPLImageInformation* lpInfo = this->getSequence()->getImageInformation(0);//lpSeqPair->left->getImageInformation();

	this->setSize( lpInfo->srcRect.getWidth(), lpInfo->srcRect.getHeight() );

	GNeutralSetting* lpSetting = getStaticData()->m_ObjectManager.m_NeutralManager.getSetting( nType );
	HPLRect rHitRect = lpSetting->m_rHitRect;
	if( rHitRect.getWidth() == 0 ) {
		this->setHitRect(0,0,lpInfo->srcRect.getWidth(), lpInfo->srcRect.getHeight() );
	} else {
		this->setHitRect( rHitRect );
	}

	this->setObjectAttribute( ObjectAttribute::HIT_TO_SHOT, true );
	this->setObjectAttribute( ObjectAttribute::HIT_TO_PLAYER, true );
	this->setObjectAttribute( ObjectAttribute::HIT_TO_ENEMY, true );
	this->setObjectAttribute( ObjectAttribute::GRAVITY, false );
	// hit area
//	this->m_nHitArea3DType = HitArea3DType::LAID;

//	this->m_nGrabType = GGrabType::NO_GRAB;

	this->m_cntDamage.setWaitFrameNum( 30 );
	this->m_cntDamage.end();

	this->m_nNextMap = -1;
	this->m_nNextScene = -1;
	switch( nType ) {
	case Sequence::Neutral::BED:
	case Sequence::Neutral::SURGEON_BED:
		this->setHitRect(1,22,155,72);
		break;
	case Sequence::Neutral::CHEST:
		this->setHitRect(15,23,65,56);
		break;
	case Sequence::Neutral::BONDAGE_WALL:
		this->setHitRect(16,1,64,88);
		break;
	case Sequence::Neutral::IRON_BALL:
		this->setHitRect(18,18,59,61);
		break;
	case Sequence::Neutral::BUNBETSU:
		this->setHitRect(24,14,46,79);
		break;
	case Sequence::Neutral::HIJIRI:
	case Sequence::Neutral::IKEN_DOLL:
	case Sequence::Neutral::LIME:
	case Sequence::Neutral::TOZICO:
	case Sequence::Neutral::TINA_DOLL:
	case Sequence::Neutral::TINSURA:
	case Sequence::Neutral::SUMANEKO:
	case Sequence::Neutral::MENTER:
	case Sequence::Neutral::SANDE:
		// TODO hit rect
//		this->m_nGrabType = GGrabType::LIFT;
		break;
	}

}

void GNeutral::die(HPLShootingObject* damageSource) {
	this->setAlive( false );
}
void GNeutral::damage( float fDamage, HPLShootingObject* lpDamageSource, int nNextState ) {
	this->m_cntDamage.reset();
}

void GNeutral::draw() {
	HPLScroller* lpScroller = getStaticData()->m_ScrollManager.getScroller(0);
	const float ZOOM_RATE = 1;
	HPLVector vScreenCenter = lpScroller->getScreenPointFromVirtual( this->getCenter() );
	vScreenCenter.multiple( (float)ZOOM_RATE );
	
	HPLVector vAdd;

	if( this->getSprite() != NULL ) {
		// rotate
		float fRotateDegree = 0;
		// animation sequence
		HPLSequence* lpSeq = this->getSequence();
		// alpha
		int nAlpha = 255;
		int nBlendMode = DX_BLENDMODE_NOBLEND;

		if( this->m_cntDamage.isAlive() ) {
			if( this->m_cntDamage.getStepCounter() == 2 ) {
				vAdd.setX( 1 );
			}
			if( ! getStaticData()->m_Game.isTheWorld()) {
				this->m_cntDamage.step();
			}
		}

		// draw object
		getStaticData()->m_Basic.m_Graphics.draw(
			(int)( vScreenCenter.getX() + vAdd.getX() ), (int)( vScreenCenter.getY() + vAdd.getY()), lpSeq, this->getFaceDirection(),
			fRotateDegree, ZOOM_RATE, nAlpha, nAlpha < 255 ? nBlendMode : DX_BLENDMODE_NOBLEND );

//		getStaticData()->m_ObjectManager.drawHitBox( this, &this->m_3DInfo,
//			HitArea3DType::LAID, lpScroller );

		switch( this->getType()) {
		case Sequence::Neutral::BATH:
			// 
			HPLSequence* lpWaterSeq = this->getSprite()->getSequence( Sequence::Neutral::BATH_WATER, FaceDirection::LEFT );
			getStaticData()->m_Basic.m_Graphics.draw(
				(int)( vScreenCenter.getX() + vAdd.getX() ), (int)( vScreenCenter.getY() + vAdd.getY()), lpWaterSeq, this->getFaceDirection(),
				fRotateDegree, ZOOM_RATE, nAlpha, nAlpha < 255 ? nBlendMode : DX_BLENDMODE_NOBLEND );

			break;
		}
		// SEnko\
		if( this->isHolding()) {
			GEnko* lpEnko = getStaticData()->m_ObjectManager.getEnko();
			HPLVector vCen = this->m_vCenter;
			HPLVector vAdd = getStaticData()->m_ObjectManager.m_NeutralManager.getHoldDeltaFromCenter( this );
			vCen.add( vAdd );
			lpEnko->m_vCenter = vCen;

			lpEnko->m_3DInfo.setZ( this->m_3DInfo.getZ()+ 1);
			lpEnko->draw();
		}
		switch( this->getType()) {
		case Sequence::Neutral::BATH:
			{
				// 
				HPLSequence* lpWaterSeq = this->getSprite()->getSequence( Sequence::Neutral::BATH_WATER_FRONT, FaceDirection::LEFT );
				const int FRONT_ALPHA = 180;
				getStaticData()->m_Basic.m_Graphics.draw(
					(int)( vScreenCenter.getX() + vAdd.getX() ), (int)( vScreenCenter.getY() + vAdd.getY()), lpWaterSeq, this->getFaceDirection(),
					fRotateDegree, ZOOM_RATE, FRONT_ALPHA, DX_BLENDMODE_ALPHA);
			}
			break;
		}
		if( ! getStaticData()->m_Game.isTheWorld() ) {
			// Aj[V
			lpSeq->step();
		}
	}
}
HPLSequence* GNeutral::getSequence() {
	int nSeqID = this->getSequenceID();

	HPLSequence* lpSeq = this->getSprite()->getSequence(
		nSeqID, FaceDirection::LEFT );
	return lpSeq;

}
void GNeutral::changeState( int nState ) {
	int nPrevState = this->getState()->getState();
	if( nState != nPrevState ) {
		// reset animation
		HPLSequence* lpSeq = this->getSequence( );
		lpSeq->resetCounter();
	}
	this->setState( nState );
}
int GNeutral::getSequenceID() {
	// state
	int st = this->getState()->getState();

	// special
	switch( this->getType()) {
	case Sequence::Neutral::RUNNING_MACHINE:
		switch( st ) {
		case StateType::WALK:
			return Sequence::Neutral::RUNNING_MACHINE_WALK;
		case StateType::DASH:
			return Sequence::Neutral::RUNNING_MACHINE_RUNNING;
		}
		break;
	}
	return this->getType();
}
